Name: uClibc
Version: 0.9.32
Release: b1
Summary: C library for embedded Linux

Group: Development/Libraries
License: LGPLv2
URL: http://www.uclibc.org/
Source0: http://www.uclibc.org/downloads/%{name}-%{version}.tar.bz2
#Source1: uClibc.config
#BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
#BuildArchitectures: i586

%global debug_package %{nil}
# This package only contains a static library

#ExcludeArch: ppc64
# uclibc 0.9.30 does not support ppc64

%description
uClibc is a C library for developing embedded Linux systems.
It is much smaller than the GNU C Library, but nearly all applications
supported by glibc also work perfectly with uClibc.

%package devel
Summary: Header files and libraries for uClibc library
Group: Development/Libraries
Provides: uClibc-static = %{version}-%{release}

%description devel
uClibc is a C library for developing embedded Linux systems.
It is much smaller than the GNU C Library, but nearly all applications
supported by glibc also work perfectly with uClibc.
This package contains the header files and libraries
needed for uClibc package.

%prep
%setup -q
#cat %{SOURCE1} >.config1
#iconv -f windows-1252 -t utf-8 README >README.pom
#mv README.pom README

%build
#mkdir kernel-include
#cp -a /usr/include/asm kernel-include
#cp -a /usr/include/asm-generic kernel-include
#cp -a /usr/include/linux kernel-include

##arch=`uname -m | sed -e 's/i.86/i386/' -e 's/ppc/powerpc/'`
arch=`uname -m | sed -e 's/i.86/i386/' -e 's/ppc/powerpc/' -e 's/armv.*/armv5tel/'`
#echo "TARGET_$arch=y" >.config
#echo "TARGET_ARCH=\"$arch\"" >>.config
##cat .config1 >>.config
#cat berry/uClibc.config >>.config
#[ "$arch" = "armv5tel" ] && sed -e 's/ARCH_LITTLE_ENDIAN=y//' -i .config
cat berry/uClibc.config >.config
[ "$arch" = "armv5tel" ] && cat berry/uClibc-armv7l.config >.config

yes "" | make oldconfig %{?_smp_mflags}
make V=1 %{?_smp_mflags}

pushd berry/gcc-uClibc
#make NATIVE_CC=gcc TARGET_ARCH=i386 DEVEL_PREFIX=/usr/lib/uClibc
make NATIVE_CC=gcc TARGET_ARCH=$arch DEVEL_PREFIX=/usr/lib/uClibc
popd

%install
rm -rf $RPM_BUILD_ROOT
make install DEVEL_PREFIX="$RPM_BUILD_ROOT/"
#make install_kernel_headers DEVEL_PREFIX="$RPM_BUILD_ROOT/"
make install_headers DEVEL_PREFIX="$RPM_BUILD_ROOT/"

# move libraries to proper subdirectory
#mkdir -p $RPM_BUILD_ROOT/%{_libdir}/uClibc
#mv  $RPM_BUILD_ROOT/lib/*  $RPM_BUILD_ROOT/%{_libdir}/uClibc/
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/uClibc/{include,lib}
mv  $RPM_BUILD_ROOT/lib/*  $RPM_BUILD_ROOT/%{_libdir}/uClibc/lib
rm -rf  $RPM_BUILD_ROOT/lib/

# move the header files to /usr subdirectory
#mkdir -p $RPM_BUILD_ROOT/%{_includedir}/uClibc
#mv  $RPM_BUILD_ROOT/include/*  $RPM_BUILD_ROOT/%{_includedir}/uClibc
mv  $RPM_BUILD_ROOT/include/*  $RPM_BUILD_ROOT/%{_libdir}/uClibc/include
rm -rf  $RPM_BUILD_ROOT/include/
ln -s /usr/include/linux $RPM_BUILD_ROOT/%{_libdir}/uClibc/include
ln -s /usr/include/asm $RPM_BUILD_ROOT/%{_libdir}/uClibc/include
ln -s /usr/include/asm-generic $RPM_BUILD_ROOT/%{_libdir}/uClibc/include

install -s -m755 berry/gcc-uClibc/*-uclibc-gcc $RPM_BUILD_ROOT/%{_libdir}/uClibc

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(-,root,root,-)
#%doc README docs/Glibc_vs_uClibc_Differences.txt docs/threads.txt docs/uClibc_vs_SuSv3.txt
#%doc TODO DEDICATION.mjn3 MAINTAINERS
#%doc docs/PORTING COPYING.LIB
#%{_includedir}/uClibc
%{_libdir}/uClibc

%changelog
* Wed Apr 27 2011 Yuichiro Nakada <berry@rberry.co.cc>
- Update to 0.9.32
* Fri Aug 13 2010 Yuichiro Nakada <berry@rberry.co.cc>
- Update to 0.9.31
* Wed Jul 1 2009 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
